﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1TrueDBGrid;

namespace TDB_CustomFiltering
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataView dv = new DataView();
        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'c1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
            this.employeesTableAdapter.Fill(this.c1NWINDDataSet.Employees);
            // TODO: This line of code loads data into the 'c1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
            this.employeesTableAdapter.Fill(this.c1NWINDDataSet.Employees);
            dv.Table = c1NWINDDataSet.Employees;
            this.c1TrueDBGrid1.DataSource = dv;

            c1TrueDBGrid1.FilterBar = true;
            c1TrueDBGrid1.AllowFilter = false;

           foreach ( C1DataColumn col in c1TrueDBGrid1.Columns)
            {
	            col.FilterDropdown = true;
	            col.FilterMultiSelect = true;
	            col.FilterSeparator = ';';
            }
        }

        int flag = 0;

        private void c1TrueDBGrid1_FilterChange(object sender, EventArgs e)
        {
            int int_col = 0;
            string str = null;
            //build our filter expression
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            int multi = 0;
            foreach (C1DataColumn dc in this.c1TrueDBGrid1.Columns) {
	            if (dc.FilterText.Length > 0) {
		            if (sb.Length > 0) {
			            sb.Append(" AND ");
		            }
		            if (flag == 1) {
			            if (dc.FilterText.Contains(dc.FilterSeparator)) {
				            string[] words = dc.FilterText.ToString().Split(dc.FilterSeparator);
				            foreach (string word in words) {
					            sb.Append((dc.DataField + " = " + "'" + word + "'"));
					            sb.Append(" OR ");
				            }
				            multi = 1;

			            } else {
				            //using '=' in case of filter dropdown
				            sb.Append((dc.DataField + " = " + "'" + dc.FilterText + "'"));
			            }

		            } else {
			            if (dc.DataType.Name == "Int32") {
				            int_col = 1;
				            //using 'IN' in case of filter text entered in filterbar is Integer & multiple selections are there
				            string[] words = dc.FilterText.ToString().Split(dc.FilterSeparator);
				            sb.Append(dc.DataField + " IN " + "(");
				            foreach (string word in words) {
					            if (word != null) {
						            sb.Append(word + ",");
					            }
				            }
				            str = sb.ToString().Remove(sb.ToString().Length - 1);
				            str += ")";
			            } else {
				            if (dc.FilterText.Contains(dc.FilterSeparator)) {
					            string[] words = dc.FilterText.ToString().Split(dc.FilterSeparator);
					            foreach (string word in words) {
						            sb.Append((dc.DataField + " = " + "'" + word + "'"));
						            sb.Append(" OR ");
					            }
					            multi = 1;
				            } else {
					            //using 'like' in case of filter text entered in filterbar
					            sb.Append((dc.DataField + " like " + "'" + dc.FilterText + "*'"));
				            }
			            }
		            }
	            }
            }

            // if multiple selections are there in the dropdown or in the FilterBar
            if (multi == 1) {
	            // filter the data
	            dv.RowFilter = sb.ToString().Remove(sb.Length - 3).ToString();
	            //removing the last appended OR from sb
            } else {
	            // if integer column with multiple options in filterbar
	            if (int_col == 1) {
		            //filter the data using str
		            dv.RowFilter = str;
	            } else {
		            //filter the data using sb in integer column with a single option
		            dv.RowFilter = sb.ToString();
	            }
            }


            //after filtering, set the value of flag again to default
            flag = 0;
        }

        private void c1TrueDBGrid1_FilterButtonClick(object sender, ColEventArgs e)
        {
            //if the filter button is clicked i.e., filtering the column through the filter dropdown 
            flag = 1;
        }

    }
}
